# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.2042
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.analytic_object_reference_list_dto import AnalyticObjectReferenceListDTO
from visier_platform_sdk.models.level_list_dto import LevelListDTO
from typing import Optional, Set
from typing_extensions import Self

class LeveledDetailsDTO(BaseModel):
    """
    The leveled dimension's configuration, such as its levels and settings.
    """ # noqa: E501
    level_list: Optional[LevelListDTO] = Field(default=None, description="The levels in the dimension.", alias="levelList")
    hide_null_values: Optional[StrictBool] = Field(default=None, description="If `true`, the dimension hides null values in visualizations. Default is `false`.", alias="hideNullValues")
    enable_large_dimension_search: Optional[StrictBool] = Field(default=None, description="If `true`, you can search for members in a dimension with more than 300,000 members. Default is `false` to help with performance.", alias="enableLargeDimensionSearch")
    analytic_object_list: Optional[AnalyticObjectReferenceListDTO] = Field(default=None, description="The analytic objects associated with the dimension.", alias="analyticObjectList")
    __properties: ClassVar[List[str]] = ["levelList", "hideNullValues", "enableLargeDimensionSearch", "analyticObjectList"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LeveledDetailsDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of level_list
        if self.level_list:
            _dict['levelList'] = self.level_list.to_dict()
        # override the default output from pydantic by calling `to_dict()` of analytic_object_list
        if self.analytic_object_list:
            _dict['analyticObjectList'] = self.analytic_object_list.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LeveledDetailsDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "levelList": LevelListDTO.from_dict(obj["levelList"]) if obj.get("levelList") is not None else None,
            "hideNullValues": obj.get("hideNullValues"),
            "enableLargeDimensionSearch": obj.get("enableLargeDimensionSearch"),
            "analyticObjectList": AnalyticObjectReferenceListDTO.from_dict(obj["analyticObjectList"]) if obj.get("analyticObjectList") is not None else None
        })
        return _obj


