# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.2042
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from visier_platform_sdk.models.plan_patch_consolidate_action_request_with_plan_id import PlanPatchConsolidateActionRequestWithPlanId
from visier_platform_sdk.models.plan_patch_reopen_action_request_with_plan_id import PlanPatchReopenActionRequestWithPlanId
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

PLANSPATCHREQUESTPLANITEM_ONE_OF_SCHEMAS = ["PlanPatchConsolidateActionRequestWithPlanId", "PlanPatchReopenActionRequestWithPlanId"]

class PlansPatchRequestPlanItem(BaseModel):
    """
    PlansPatchRequestPlanItem
    """
    # data type: PlanPatchConsolidateActionRequestWithPlanId
    oneof_schema_1_validator: Optional[PlanPatchConsolidateActionRequestWithPlanId] = None
    # data type: PlanPatchReopenActionRequestWithPlanId
    oneof_schema_2_validator: Optional[PlanPatchReopenActionRequestWithPlanId] = None
    actual_instance: Optional[Union[PlanPatchConsolidateActionRequestWithPlanId, PlanPatchReopenActionRequestWithPlanId]] = None
    one_of_schemas: Set[str] = { "PlanPatchConsolidateActionRequestWithPlanId", "PlanPatchReopenActionRequestWithPlanId" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = PlansPatchRequestPlanItem.model_construct()
        error_messages = []
        match = 0
        # validate data type: PlanPatchConsolidateActionRequestWithPlanId
        if not isinstance(v, PlanPatchConsolidateActionRequestWithPlanId):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PlanPatchConsolidateActionRequestWithPlanId`")
        else:
            match += 1
        # validate data type: PlanPatchReopenActionRequestWithPlanId
        if not isinstance(v, PlanPatchReopenActionRequestWithPlanId):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PlanPatchReopenActionRequestWithPlanId`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PlansPatchRequestPlanItem with oneOf schemas: PlanPatchConsolidateActionRequestWithPlanId, PlanPatchReopenActionRequestWithPlanId. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PlansPatchRequestPlanItem with oneOf schemas: PlanPatchConsolidateActionRequestWithPlanId, PlanPatchReopenActionRequestWithPlanId. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into PlanPatchConsolidateActionRequestWithPlanId
        try:
            instance.actual_instance = PlanPatchConsolidateActionRequestWithPlanId.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PlanPatchReopenActionRequestWithPlanId
        try:
            instance.actual_instance = PlanPatchReopenActionRequestWithPlanId.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PlansPatchRequestPlanItem with oneOf schemas: PlanPatchConsolidateActionRequestWithPlanId, PlanPatchReopenActionRequestWithPlanId. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PlansPatchRequestPlanItem with oneOf schemas: PlanPatchConsolidateActionRequestWithPlanId, PlanPatchReopenActionRequestWithPlanId. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], PlanPatchConsolidateActionRequestWithPlanId, PlanPatchReopenActionRequestWithPlanId]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


