# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.2042
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.multi_value_setting_dto import MultiValueSettingDTO
from visier_platform_sdk.models.single_value_setting_dto import SingleValueSettingDTO
from typing import Optional, Set
from typing_extensions import Self

class SettingsDTO(BaseModel):
    """
    The settings to configure a sidecar solution.
    """ # noqa: E501
    key: Optional[StrictStr] = Field(default=None, description="The key of the configurable setting.")
    single_config_item: Optional[SingleValueSettingDTO] = Field(default=None, description="A value containing a single string.", alias="singleConfigItem")
    multi_value_config_item: Optional[MultiValueSettingDTO] = Field(default=None, description="A value containing multiple strings.", alias="multiValueConfigItem")
    __properties: ClassVar[List[str]] = ["key", "singleConfigItem", "multiValueConfigItem"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SettingsDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of single_config_item
        if self.single_config_item:
            _dict['singleConfigItem'] = self.single_config_item.to_dict()
        # override the default output from pydantic by calling `to_dict()` of multi_value_config_item
        if self.multi_value_config_item:
            _dict['multiValueConfigItem'] = self.multi_value_config_item.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SettingsDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "key": obj.get("key"),
            "singleConfigItem": SingleValueSettingDTO.from_dict(obj["singleConfigItem"]) if obj.get("singleConfigItem") is not None else None,
            "multiValueConfigItem": MultiValueSettingDTO.from_dict(obj["multiValueConfigItem"]) if obj.get("multiValueConfigItem") is not None else None
        })
        return _obj


