# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.2042
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.vee_question_change_definitions_by_tenant_dto import VeeQuestionChangeDefinitionsByTenantDTO
from typing import Optional, Set
from typing_extensions import Self

class VeeQuestionsChangeDefinitionsDTO(BaseModel):
    """
    The changes to Vee sample questions.
    """ # noqa: E501
    questions_by_tenant: Optional[List[VeeQuestionChangeDefinitionsByTenantDTO]] = Field(default=None, description="The Vee sample question updates to make in each tenant.", alias="questionsByTenant")
    __properties: ClassVar[List[str]] = ["questionsByTenant"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VeeQuestionsChangeDefinitionsDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in questions_by_tenant (list)
        _items = []
        if self.questions_by_tenant:
            for _item_questions_by_tenant in self.questions_by_tenant:
                if _item_questions_by_tenant:
                    _items.append(_item_questions_by_tenant.to_dict())
            _dict['questionsByTenant'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VeeQuestionsChangeDefinitionsDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "questionsByTenant": [VeeQuestionChangeDefinitionsByTenantDTO.from_dict(_item) for _item in obj["questionsByTenant"]] if obj.get("questionsByTenant") is not None else None
        })
        return _obj


